您好,欢迎访问代理记账网站
移动应用 微信公众号 联系我们

咨询热线 -

电话 15988168888

联系客服
  • 价格透明
  • 信息保密
  • 进度掌控
  • 售后无忧

【Java异常】捕获和抛出异常

抛出异常

捕获异常

异常处理五个关键字

try .catch .finally .throw ,throws

首先我们来写一个会报错的方法:

package exception;

public class Test {
	public static void main(String[] args) {
		int a = 1;
		int b = 0;
		System.out.println(a/b);
	}

}

我们应该如何捕捉这个异常呢?

如下:

package exception;

public class Test {
	public static void main(String[] args) {
		int a = 1;
		int b = 0;
		
		try {//try监控区域
			System.out.println(a/b);
		}catch(ArithmeticException e){//捕获异常
			System.out.println("程序出现异常");
		}finally {//处理善后工作
			System.out.println("finally");
		}
	}

}

 

接下来我们说一下注意事项:

finally可以不要,我们学到例如IO流,资源须要关闭用来做善后工作 

再来写一个别的异常:

package exception;

public class Test {
	public static void main(String[] args) {
		int a = 1;
		int b = 0;
		
		try {//try监控区域
			new Test().a();
		}catch(ArithmeticException e){//捕获异常
			System.out.println("程序出现异常");
		}finally {//处理善后工作
			System.out.println("finally");
		}
	}
	public void a() {
		b();
	}
	public void b() {
		a();
	}

}

我们可以发现这个捕获不到,说明Error还是不一样

但是finally还是会执行

以上应该如何捕获呢

如下:

package exception;

public class Test {
	public static void main(String[] args) {
		int a = 1;
		int b = 0;
		
		try {//try监控区域
			new Test().a();
		}catch(Throwable e){//捕获异常
			System.out.println("程序出现异常");
		}finally {//处理善后工作
			System.out.println("finally");
		}
	}
	public void a() {
		b();
	}
	public void b() {
		a();
	}

}

 

catch(想要捕获的异常类型) 

假如出现多个异常也可以层层递近

package exception;

public class Test {
	public static void main(String[] args) {
		int a = 1;
		int b = 0;
		
		try {//try监控区域
			new Test().a();
		}catch(Error e){//捕获异常
			System.out.println("Error");
		}catch(Exception e){
			System.out.println("Exception");
		}catch(Throwable e){//捕获异常
			System.out.println("Throwable");
		}finally {//处理善后工作
			System.out.println("finally");
		}
	}
	public void a() {
		b();
	}
	public void b() {
		a();
	}

}

 运行:

 捕获多个异常:从小到大! 

打印错误的栈信息:

 主动抛出异常:

package exception;

public class Test {
	public static void main(String[] args) {
	
		new Test().test(1, 0);
	}
	public void test(int a,int b) {
		if (b==0) {
			throw new ArithmeticException();	
		}
		System.out.println(a/b);
	}
}

假设这方法中,处理不了这些异常,方法上抛出异常

 

package exception;

public class Test {
	public static void main(String[] args) {
	    try {
	    	new Test().test(1, 0);
	    }catch(ArithmeticException e) {
	    	e.printStackTrace();
	    } 
	}
	//假设这方法中,处理不了这些异常,方法上抛出异常
	public void test(int a,int b) throws ArithmeticException{
		if (b==0) {//throw throws
			throw new ArithmeticException();	//主动的抛出异常,一般在方法中使用
		}
	}
}

捕获后程序可继续运行

感谢观看!!! 


分享:

低价透明

统一报价,无隐形消费

金牌服务

一对一专属顾问7*24小时金牌服务

信息保密

个人信息安全有保障

售后无忧

服务出问题客服经理全程跟进